
// *************************************************************************************************
// 初期化
// *************************************************************************************************
function init()
{
	// 年をインプットボックスに設定
	var d = new Date();
	document.formmain.formyear.value = d.getFullYear();

	// カレンダー表示
	dispCalendar();
}



// *************************************************************************************************
// カレンダー表示
// *************************************************************************************************
function dispCalendar()
{
	var str_html = '';														// 出力用HTML
	var option_startweek = 0;												// 月初めの曜日（0:日 1:月 2:火 3:水 4:木 5:金 6:土）
	var year, month, day;													// 年月日
	var week = 0;															// 曜日
	var arr_week = new Array("SUN","MON","TUE","WED","THU","FRI","SAT");	// 曜日の文字列
	var tableval = [];														// 表内容の配列
	var monthdays = 0;														// 月の日数
	var startweek = 0;														// 月初めの曜日
	var holiday = 0;														// 祝日かどうか
	var sunday = 0;															// 日曜日かどうか
	var saturday = 0;														// 土曜日かどうか
	var i, j, k;
	var x, y;

	// 年の取得
	if (!document.formmain.formyear.value) {
		year = 0;
	} else {
		year = parseInt(document.formmain.formyear.value);
	}


	// *********************************************************************************************
	// 出力用HTMLの作成
	// *********************************************************************************************
	// 見出し
	str_html += '<header>\n';
	str_html += '\t<h1>' + year + ' CALENDAR</h1>\n';
	str_html += '</header>\n';

	month = 1;
	str_html += '<table>\n';
	for (i = 0; i < 4; i++) {
		str_html += '\t<tr>\n';
		for (j = 0; j < 3; j++) {
			str_html += '\t\t<td class="calbox">\n';

			str_html += '\t\t\t<table class="calendar">\n';
			// -------------------------------------------------------------------------------------
			// 月
			// -------------------------------------------------------------------------------------
			str_html += '\t\t\t\t<tr><td class="monthtitle" colspan="7">' + month + '</td></tr>\n';
			// -------------------------------------------------------------------------------------
			// 曜日
			// -------------------------------------------------------------------------------------
			week = option_startweek;
			str_html += '\t\t\t\t<tr class="week">';
			for (k = 0; k < 7; k++) {
				if (week === 0) {			str_html += '<th class="sunday">';
				} else if (week === 6) {	str_html += '<th class="saturday">';
				} else {					str_html += '<th>';
				}
				str_html += arr_week[week] + '</th>';
				week++;
				if (week >= 7) week = 0;
			}
			str_html += '</tr>\n';


			// -------------------------------------------------------------------------------------
			// 前処理
			// -------------------------------------------------------------------------------------
			// 月の日数を取得
			monthdays = new Date(year, month, 0).getDate();
			// 月初めの曜日を取得
			startweek = new Date(year, month - 1).getDay();

			week = startweek - option_startweek;
			sunday = 0 - option_startweek;
			saturday = 6 - option_startweek;
			if (week < 0) week += 7;
			if (sunday < 0) sunday += 7;
			if (saturday < 0) saturday += 7;
			// 表内容の配列を初期化
			for (k = 0; k < 7 * 6; k++) tableval[k] = 0;
			// 表内容の配列に日付を代入
			for (k = 0; k < monthdays; k++) tableval[k + week] = k + 1;


			// -------------------------------------------------------------------------------------
			// 日付
			// -------------------------------------------------------------------------------------
			week = option_startweek;
			for (y = 0; y < 6; y++) {
				str_html += '\t\t\t\t<tr>';
				for (x = 0; x < 7; x++) {
					day = tableval[x + (y * 7)];
					if (day === 0) {
						str_html += '<td>&nbsp;</td>';
					} else {
						// 指定日が祝日かどうか
						holiday = getHoliday(year, month, day);
						if (holiday > 0) {			str_html += '<td class="holiday">';
						} else if (week === 0) {	str_html += '<td class="sunday">';
						} else if (week === 6) {	str_html += '<td class="saturday">';
						} else {					str_html += '<td>';
						}
						str_html += day + '</td>';
					}
					week++;
					if (week >= 7) week = 0;
				}
				str_html += '</tr>\n';
			}

			str_html += '\t\t\t</table>\n';
			str_html += '\t\t</td>\n';
			month++;
		}
		str_html += '\t</tr>\n';
	}
	str_html += '</table>\n';

	document.getElementById('output').innerHTML = str_html;
}



// *************************************************************************************************
// 指定日が祝日（休日）かどうか
// 【戻り値】
// 		0: 平日
// 		1: 元旦（１月１日）
// 		2: 成人の日（１月第２月曜日）
// 		3: 建国記念の日（２月１１日）
// 		4: 春分の日（３月２１日ごろ）
// 		5: 昭和の日（４月２９日）
// 		6: 憲法記念日（５月３日）
// 		7: みどりの日（５月４日）
// 		8: こどもの日（５月５日）
// 		9: 海の日（７月第３月曜日）
// 		10: 山の日（８月１１日）
// 		11: 敬老の日（９月第３月曜日）
// 		12: 秋分の日（９月２３日ごろ）
// 		13: 体育の日（１０月第２月曜日）
// 		14: 文化の日（１１月３日）
// 		15: 勤労感謝の日（１１月２３日）
// 		16: 天皇誕生日（１２月２３日）
// 		17: 振替休日
// 		18: 国民の休日（前後が「国民の祝日」で挟まれた平日）
// *************************************************************************************************
function getHoliday(year, month, day)
{
	var week;
	var specialday;

	if (month === 1) {
		if (day === 1) return 1;									// 1: 元旦（１月１日）
		if (day === 2) {
			week = new Date(year, month - 1, 1).getDay();
			if (week === 0) return 17;								// 17: 振替休日
		}
		if (Math.floor((day - 1) / 7) === 1) {
			week = new Date(year, month - 1, day).getDay();
			if (week === 1) return 2;								// 2: 成人の日（１月第２月曜日）
		}
	} else if (month === 2) {
		if (day === 11) return 3;									// 3: 建国記念の日（２月１１日）
		if (day === 12) {
			week = new Date(year, month - 1, 11).getDay();
			if (week === 0) return 17;								// 17: 振替休日
		}
	} else if (month === 3) {
		if (day >= 19 && day <= 22) {
			// 春分の日を取得
			specialday = getVernalEquinoxDay(year);
			if (day === specialday) return 4;						// 4: 春分の日（３月２１日ごろ）
			if (day === specialday + 1) {
				week = new Date(year, month - 1, specialday).getDay();
				if (week === 0) return 17;							// 17: 振替休日
			}
		}
	} else if (month === 4) {
		if (day === 29) return 5;									// 5: 昭和の日（４月２９日）
		if (day === 30) {
			week = new Date(year, month - 1, 29).getDay();
			if (week === 0) return 17;								// 17: 振替休日
		}
	} else if (month === 5) {
		if (day === 3) return 6;									// 6: 憲法記念日（５月３日）
		if (day === 4) return 7;									// 7: みどりの日（５月４日）
		if (day === 5) return 8;									// 8: こどもの日（５月５日）
		if (day === 6) {
			week = new Date(year, month - 1, 3).getDay();
			if (week === 5 || week === 6 || week === 0) return 17;	// 17: 振替休日
		}
	} else if (month === 7) {
		if (Math.floor((day - 1) / 7) === 2) {
			week = new Date(year, month - 1, day).getDay();
			if (week === 1) return 9;								// 9: 海の日（７月第３月曜日）
		}
	} else if (year >= 2016 && month === 8) {
		if (day === 11) return 10;									// 10: 山の日（８月１１日）
		if (day === 12) {
			week = new Date(year, month - 1, 11).getDay();
			if (week === 0) return 17;								// 17: 振替休日
		}
	} else if (month === 9) {
		if (Math.floor((day - 1) / 7) === 2) {
			week = new Date(year, month - 1, day).getDay();
			if (week === 1) return 11;								// 11: 敬老の日（９月第３月曜日）
		}
		if (day >= 21 && day <= 25) {
			// 秋分の日を取得
			specialday = getAutumnalEquinoxDay(year);
			if (day === specialday) return 12;						// 12: 秋分の日（９月２３日ごろ）
			week = new Date(year, month - 1, specialday).getDay();
			if (day === specialday + 1) {
				if (week === 0) return 17;							// 17: 振替休日
			}
			if (week === 3 && day === specialday - 1) return 18;	// 18: 国民の休日
		}
	} else if (month === 10) {
		if (Math.floor((day - 1) / 7) === 1) {
			week = new Date(year, month - 1, day).getDay();
			if (week === 1) return 13;								// 13: 体育の日（１０月第２月曜日）
		}
	} else if (month === 11) {
		if (day === 3) return 14;									// 14: 文化の日（１１月３日）
		if (day === 4) {
			week = new Date(year, month - 1, 3).getDay();
			if (week === 0) return 17;								// 17: 振替休日
		}
		if (day === 23) return 15;									// 15: 勤労感謝の日（１１月２３日）
		if (day === 24) {
			week = new Date(year, month - 1, 23).getDay();
			if (week === 0) return 17;								// 17: 振替休日
		}
	} else if (month === 12) {	
		if (day === 23) return 16;									// 16: 天皇誕生日（１２月２３日）
		if (day === 24) {
			week = new Date(year, month - 1, 23).getDay();
			if (week === 0) return 17;								// 17: 振替休日
		}
	}
	return 0;
}



// *************************************************************************************************
// 春分の日を取得（1900年～2150年まで対応）
// *************************************************************************************************
function getVernalEquinoxDay(year)
{
	if (year <= 1979) {			return Math.floor(20.8357 + (0.242194 * (year - 1980)) - Math.floor((year - 1983) / 4));
	} else if (year <= 2099) {	return Math.floor(20.8431 + (0.242194 * (year - 1980)) - Math.floor((year - 1980) / 4));
	} else if (year <= 2150) {	return Math.floor(21.8510 + (0.242194 * (year - 1980)) - Math.floor((year - 1980) / 4));
	}
	return 0;
}



// *************************************************************************************************
// 秋分の日を取得（1900年～2150年まで対応）
// *************************************************************************************************
function getAutumnalEquinoxDay(year)
{
	if (year <= 1979) {			return Math.floor(23.2588 + (0.242194 * (year - 1980)) - Math.floor((year - 1983) / 4));
	} else if (year <= 2099) {	return Math.floor(23.2488 + (0.242194 * (year - 1980)) - Math.floor((year - 1980) / 4));
	} else if (year <= 2150) {	return Math.floor(24.2488 + (0.242194 * (year - 1980)) - Math.floor((year - 1980) / 4));
	}
	return 0;
}
